/*
DO NOT EDIT THIS FILE!

This file is autogenerated from "--update" and will be replaced
every build time

*/

#ifndef DRAWMODULEBASE_H
#define DRAWMODULEBASE_H

// Custom types declaration headers (if any)
#include "../_colorer/typecolor.h"


// Kumir includes
#include <kumir2-libs/extensionsystem/kplugin.h>

// Qt includes
#include <QtCore>
#if QT_VERSION >= 0x050000
#   include <QtWidgets>
#else
#   include <QtGui>
#endif

namespace ActorDraw {

typedef Actor_Colorer::Color Color;


class DrawModuleBase
    : public QObject
{
    Q_OBJECT
public /* methods */:
    DrawModuleBase(ExtensionSystem::KPlugin* parent);
    QList<QMenu*> moduleMenus() const;
    QDir myResourcesDir() const;
    ExtensionSystem::SettingsPtr mySettings() const;
    virtual QWidget* mainWidget() const = 0;
    virtual QWidget* pultWidget() const = 0;
    virtual void handleGuiReady();
    virtual QString initialize(const QStringList &configurationParameters, const ExtensionSystem::CommandLine & runtimeParameters);
    virtual bool isSafeToQuit();
    virtual QVariantList templateParameters() const;
public Q_SLOTS:
    virtual void reset() = 0;
    virtual void reloadSettings(ExtensionSystem::SettingsPtr settings, const QStringList & keys) = 0;
    virtual void changeGlobalState(ExtensionSystem::GlobalState old, ExtensionSystem::GlobalState current) = 0;
    virtual void terminateEvaluation() = 0;
    virtual void setAnimationEnabled(bool enabled) = 0;
    virtual void runSetupPen() = 0;
    virtual void runReleasePen() = 0;
    virtual void runSetPenColor(const Color& color) = 0;
    virtual void runMoveTo(const qreal x, const qreal y) = 0;
    virtual void runMoveBy(const qreal dX, const qreal dY) = 0;
    virtual void runAddCaption(const qreal width, const QString& text) = 0;
    virtual bool runIsLineAtCircle(const qreal x, const qreal y, const qreal radius) = 0;
    virtual void loadActorData(QIODevice * source);
Q_SIGNALS:
    void notifyOnTemplateParametersChanged();


    /* ========= CLASS PRIVATE ========= */
protected /* methods */:
    const ExtensionSystem::CommandLine& commandLineParameters() const;
    void msleep(unsigned long msecs);
    void setError(const QString & errorText);
    void sleep(unsigned long secs);
    void usleep(unsigned long usecs);



protected /* fields */:
    QMenu* m_menuDraw;
    QAction* m_actionDrawLoadDrawing;
    QAction* m_actionDrawSaveDrawing;

};
        

} // namespace ActorDraw

#endif // DRAWMODULEBASE_H
