/*
DO NOT EDIT THIS FILE!

This file is autogenerated from "--update" and will be replaced
every build time

*/

// Self include
#include "keyboardplugin.h"
#include "keyboardmodulebase.h"
#include "keyboardmodule.h"

namespace ActorKeyboard {


QVariant encode(const Keycode & record) {
    QVariantList result;
    result << QVariant(record.code);

    return result;
}

Keycode decode(const QVariant & raw) {
    Keycode result;
    const QVariantList alist = raw.toList();
    result.code = alist.size() > 0 ? alist.at(0).toInt() : 0;

    return result;
}
            


KeyboardPlugin::KeyboardPlugin()
    : ExtensionSystem::KPlugin()
    , module_(nullptr)
    , asyncRunThread_(nullptr)
    , settingsPage_(nullptr)
{
    bool hasGuiThread = true;
#ifdef Q_OS_LINUX
    hasGuiThread = getenv("DISPLAY") != 0;
#endif
    QObject::connect(
        this, SIGNAL(asyncRun(quint32,QVariantList)),
        this, SLOT(asyncEvaluate(quint32,QVariantList)),
        //hasGuiThread? Qt::QueuedConnection :
        Qt::DirectConnection
    );
}

/* protected */ QList<ExtensionSystem::CommandLineParameter> KeyboardPlugin::acceptableCommandLineParameters() const
{
    return KeyboardModule::acceptableCommandLineParameters();
}

/* public */ QVariantList KeyboardPlugin::algOptResults() const
{
    return optResults_;
}

/* public */ QByteArray KeyboardPlugin::asciiModuleName() const
{
    return QByteArray("Keyboard");
}

/* private slot */ void KeyboardPlugin::asyncEvaluate(quint32 index, const QVariantList & args)
{
    using namespace Shared;
    errorText_.clear();
    result_ = QVariant::Invalid;
    optResults_.clear();
    switch (index) {
        case 0x0002: {
            /* clear key buffer */
            module_->runClearKeyBuffer();
            break;
        }
        
        
        default : {
            errorText_ = "Unknown method index for async evaluation";
        }
    }
    Q_EMIT sync();
}

/* protected */ void KeyboardPlugin::changeGlobalState(ExtensionSystem::GlobalState old, ExtensionSystem::GlobalState current)
{
    module_->changeGlobalState(old, current);
}

/* public */ void KeyboardPlugin::connectSync(QObject* receiver, const char* method)
{
    QObject::connect(this, SIGNAL(sync()), receiver, method, Qt::DirectConnection);
}

/* protected */ void KeyboardPlugin::createPluginSpec()
{
    _pluginSpec.name = "ActorKeyboard";
    _pluginSpec.gui = isGuiRequired();
}

/* public */ QVariant KeyboardPlugin::customValueFromString(const QByteArray & clazz, const QString & stringg) const
{
    QVariant result;
    if (clazz==QByteArray("keycode")) {
        Keycode x; bool ok = false;
        x = module_->runOperatorINPUT(stringg, ok);
        if (ok) {
            result = encode(x);
        }
    }

    return result;
}

/* public */ QString KeyboardPlugin::customValueToString(const QByteArray & clazz, const QVariant & value) const
{
    QString result;
    if (clazz==QByteArray("keycode")) {
        Keycode x = decode(value);
        result = module_->runOperatorOUTPUT(x);
    }

    return result;
}

/* public */ QVariantList KeyboardPlugin::defaultTemplateParameters() const
{
    QVariantList result;
    return result;
}

/* public */ QString KeyboardPlugin::errorText() const
{
    return errorText_;
}

/* public */ Shared::EvaluationStatus KeyboardPlugin::evaluate(quint32 index, const QVariantList & args)
{
    using namespace Shared;
    errorText_.clear();
    result_ = QVariant::Invalid;
    optResults_.clear();
    switch (index) {
        case 0x0000: {
            /* key hit */
            result_ = QVariant::fromValue(module_->runKeyHit());
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0001: {
            /* key code */
            result_ = QVariant::fromValue(module_->runKeyCode());
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0002: {
            /* clear key buffer */
            Q_EMIT asyncRun(index, args);
            return ES_Async;
            break;
        }
        
        case 0x0003: {
            /* input */
            QString s = qvariant_cast<QString>(args[0]);
            bool ok = qvariant_cast<bool>(args[1]);
            result_ = encode(module_->runOperatorINPUT(s, ok));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::fromValue(ok);
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackRezResult;
            break;
        }
        
        case 0x0004: {
            /* output */
            Keycode x = decode(args[0]);
            result_ = QVariant::fromValue(module_->runOperatorOUTPUT(x));
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0005: {
            /* := */
            int x = qvariant_cast<int>(args[0]);
            result_ = encode(module_->runOperatorASSIGN(x));
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0006: {
            /* := */
            Keycode x = decode(args[0]);
            result_ = QVariant::fromValue(module_->runOperatorASSIGN(x));
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0007: {
            /* = */
            Keycode self = decode(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorEQUAL(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0008: {
            /* = */
            Keycode self = decode(args[0]);
            int other = qvariant_cast<int>(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorEQUAL(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0009: {
            /* = */
            int self = qvariant_cast<int>(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorEQUAL(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x000a: {
            /* <> */
            Keycode self = decode(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorNOTEQUAL(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x000b: {
            /* <> */
            Keycode self = decode(args[0]);
            int other = qvariant_cast<int>(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorNOTEQUAL(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x000c: {
            /* <> */
            int self = qvariant_cast<int>(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorNOTEQUAL(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x000d: {
            /* < */
            Keycode self = decode(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorLESS(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x000e: {
            /* < */
            Keycode self = decode(args[0]);
            int other = qvariant_cast<int>(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorLESS(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x000f: {
            /* < */
            int self = qvariant_cast<int>(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorLESS(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0010: {
            /* > */
            Keycode self = decode(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorGREATER(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0011: {
            /* > */
            Keycode self = decode(args[0]);
            int other = qvariant_cast<int>(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorGREATER(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0012: {
            /* > */
            int self = qvariant_cast<int>(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorGREATER(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0013: {
            /* + */
            Keycode self = decode(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorPLUS(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0014: {
            /* + */
            int self = qvariant_cast<int>(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorPLUS(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0015: {
            /* + */
            Keycode self = decode(args[0]);
            int other = qvariant_cast<int>(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorPLUS(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0016: {
            /* - */
            Keycode self = decode(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorMINUS(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0017: {
            /* - */
            int self = qvariant_cast<int>(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorMINUS(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0018: {
            /* - */
            Keycode self = decode(args[0]);
            int other = qvariant_cast<int>(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorMINUS(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x0019: {
            /* * */
            Keycode self = decode(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorASTERISK(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x001a: {
            /* * */
            int self = qvariant_cast<int>(args[0]);
            Keycode other = decode(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorASTERISK(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        case 0x001b: {
            /* * */
            Keycode self = decode(args[0]);
            int other = qvariant_cast<int>(args[1]);
            result_ = QVariant::fromValue(module_->runOperatorASTERISK(self, other));
            optResults_ << QVariant::Invalid;
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_StackResult;
            break;
        }
        
        
        default : {
            errorText_ = "Unknown method index";
            return ES_Error;
        }
    }
}

/* public */ Shared::ActorInterface::FunctionList KeyboardPlugin::functionList() const
{
    Shared::ActorInterface::FunctionList result;
    
    /* алг лог сигнал клав */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("key hit");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("сигнал клав");
    result.last().returnType = Shared::ActorInterface::Bool;
    
    /* алг цел код клав */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("key code");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("код клав");
    result.last().returnType = Shared::ActorInterface::Int;
    
    /* алг сброс клав */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("clear key buffer");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("сброс клав");
    result.last().returnType = Shared::ActorInterface::Void;
    
    /* алг сканкод ввод(лит s, рез лог ok) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("input");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("ввод");
    result.last().returnType = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().returnTypeSpecification = recordSpec;
    }
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::String;
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::OutArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Bool;
    result.last().arguments.last().dimension = 0u;
    
    /* алг лит вывод(сканкод x) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("output");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("вывод");
    result.last().returnType = Shared::ActorInterface::String;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг сканкод :=(цел x) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray(":=");
    result.last().returnType = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().returnTypeSpecification = recordSpec;
    }
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    
    /* алг цел :=(сканкод x) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray(":=");
    result.last().returnType = Shared::ActorInterface::Int;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог =(сканкод self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("=");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог =(сканкод self, цел other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("=");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог =(цел self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("=");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог <>(сканкод self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("<>");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог <>(сканкод self, цел other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("<>");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог <>(цел self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("<>");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог <(сканкод self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("<");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог <(сканкод self, цел other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("<");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог <(цел self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("<");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог >(сканкод self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray(">");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог >(сканкод self, цел other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray(">");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    
    /* алг лог >(цел self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray(">");
    result.last().returnType = Shared::ActorInterface::Bool;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг цел +(сканкод self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("+");
    result.last().returnType = Shared::ActorInterface::Int;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг цел +(цел self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("+");
    result.last().returnType = Shared::ActorInterface::Int;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг цел +(сканкод self, цел other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("+");
    result.last().returnType = Shared::ActorInterface::Int;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    
    /* алг цел -(сканкод self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("-");
    result.last().returnType = Shared::ActorInterface::Int;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг цел -(цел self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("-");
    result.last().returnType = Shared::ActorInterface::Int;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг цел -(сканкод self, цел other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("-");
    result.last().returnType = Shared::ActorInterface::Int;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    
    /* алг цел *(сканкод self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("*");
    result.last().returnType = Shared::ActorInterface::Int;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг цел *(цел self, сканкод other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("*");
    result.last().returnType = Shared::ActorInterface::Int;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг цел *(сканкод self, цел other) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("*");
    result.last().returnType = Shared::ActorInterface::Int;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Int;
    result.last().arguments.last().dimension = 0u;
    ;
    return result;
}

/* private slot */ void KeyboardPlugin::handleSettingsChangedCppImplementation(const QStringList & keys)
{
    if (module_) {
        module_->reloadSettings(mySettings(), keys);
    }
}

/* protected */ QString KeyboardPlugin::initialize(const QStringList &a, const ExtensionSystem::CommandLine &b)
{
    module_ = new KeyboardModule(this);
    asyncRunThread_ = new KeyboardAsyncRunThread(this, module_);
    QObject::connect(asyncRunThread_, SIGNAL(finished()),
                     this, SIGNAL(sync()));
    QObject::connect(module_, SIGNAL(notifyOnTemplateParametersChanged()),
                     this, SIGNAL(notifyOnTemplateParametersChanged()));
    
    return module_->initialize(a, b);
}

/* public */ bool KeyboardPlugin::isGuiRequired() const
{
    return true;
}

/* public */ bool KeyboardPlugin::isSafeToQuit()
{
    return module_->isSafeToQuit();
}

/* public slot */ void KeyboardPlugin::loadActorData(QIODevice * source)
{
    if (module_) {
        module_->loadActorData(source);
    }
}

/* public */ QString KeyboardPlugin::localizedModuleName(const QLocale::Language ) const
{
    // TODO non-Russian languages not implemented yet
    return QString::fromUtf8("Клавиатура");
}

/* public */ QString KeyboardPlugin::mainIconName() const
{
    return QString::fromLatin1("");
}

/* public */ QWidget* KeyboardPlugin::mainWidget()
{
    return module_->mainWidget();
}

/* public */ QList<QMenu*> KeyboardPlugin::moduleMenus() const
{
    return module_->moduleMenus();
}

/* protected */ void KeyboardPlugin::msleep(unsigned long secs)
{
    //if (QThread::currentThread()==asyncRunThread_) {
        asyncRunThread_->amsleep(secs);
    //}
}

/* public */ void KeyboardPlugin::notifyGuiReady()
{
    module_->handleGuiReady();
}

/* public */ QString KeyboardPlugin::pultIconName() const
{
    return QString::fromLatin1("");
}

/* public */ QWidget* KeyboardPlugin::pultWidget()
{
    return module_->pultWidget();
}

/* public */ void KeyboardPlugin::reset()
{
    module_->reset();
}

/* public */ QVariant KeyboardPlugin::result() const
{
    return result_;
}

/* public */ void KeyboardPlugin::setAnimationEnabled(bool enabled)
{
    // The module might be not created at a time of call,
    // so check it propertly
    if (module_) {
        module_->setAnimationEnabled(enabled);
    }
}

/* public */ QWidget* KeyboardPlugin::settingsEditorPage()
{
    return settingsPage_;
}

/* protected */ void KeyboardPlugin::sleep(unsigned long secs)
{
    if (QThread::currentThread()==asyncRunThread_) {
        asyncRunThread_->asleep(secs);
    }
}

/* public */ QVariantList KeyboardPlugin::templateParameters() const
{
    if (module_) {
        return module_->templateParameters();
    }
    else {
        return defaultTemplateParameters();
    }
}

/* public */ void KeyboardPlugin::terminateEvaluation()
{
    module_->terminateEvaluation();
}

/* public */ Shared::ActorInterface::TypeList KeyboardPlugin::typeList() const
{
    Shared::ActorInterface::TypeList result;
    
            {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("code"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("keycode");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("сканкод");
        result.push_back(recordSpec);
    }
    
    return result;
}

/* private */ void KeyboardPlugin::updateSettings(const QStringList & keys)
{
    if (settingsPage_) {
        settingsPage_->setSettingsObject(mySettings());
    }
    if (module_) {
        module_->reloadSettings(mySettings(), keys);
    }
}

/* public */ QList<Shared::ActorInterface*> KeyboardPlugin::usesList() const
{
    static const QList<Shared::ActorInterface*> empty = QList<Shared::ActorInterface*>();
    return empty;
}

/* protected */ void KeyboardPlugin::usleep(unsigned long secs)
{
    if (QThread::currentThread()==asyncRunThread_) {
        asyncRunThread_->ausleep(secs);
    }
}



KeyboardAsyncRunThread::KeyboardAsyncRunThread(class KeyboardPlugin* plugin, class KeyboardModuleBase* module)
    : QThread(plugin)
    , index_(0)
    , args_(QVariantList())
    , plugin_(plugin)
    , module_(module)
{
}

/* public */ void KeyboardAsyncRunThread::amsleep(unsigned long secs)
{
    msleep(secs);
}

/* public */ void KeyboardAsyncRunThread::asleep(unsigned long secs)
{
    sleep(secs);
}

/* public */ void KeyboardAsyncRunThread::ausleep(unsigned long secs)
{
    usleep(secs);
}

/* public */ void KeyboardAsyncRunThread::init(quint32 index, const QVariantList & args)
{
    index_ = index;
    args_ = args;
}

/* private */ void KeyboardAsyncRunThread::run()
{
    switch (index_) {
        case 0x0002: {
            /* clear key buffer */
            module_->runClearKeyBuffer();
            break;
        }
        
        default: {
            plugin_->errorText_ = "Unknown method index";
        }
    }
}



} // namespace ActorKeyboard
#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN(ActorKeyboard::KeyboardPlugin)
#endif
