#ifndef PREAMBULE_TEX_H
#define PREAMBULE_TEX_H

namespace docbook2latex {

const char * PREAMBULE = ""
        "\\documentclass[%%classparam%%]{%%class%%}\n"
        "\\usepackage[%%paper%%]{geometry}\n"
        "\\geometry{%%geometry%%}\n"
        "\\usepackage[koi8-r]{inputenc}\n"
        "\\usepackage[T1,T2A]{fontenc}\n"
        "\\usepackage[russian]{babel}\n"
        "\\usepackage{indentfirst}\n"
        "\\usepackage[pdftex,colorlinks=%%colorlinks%%,bookmarks=true,bookmarksnumbered=true,bookmarksopen=true]{hyperref}\n\n"
        "\\usepackage[pdftex]{color}\n"
        "\\usepackage{titlesec}\n"
        "\\usepackage{textcase}\n"
        "\\usepackage{fancyhdr}\n"
        "\\usepackage{listings}\n"
        "\\usepackage{xparse}\n"
        "\\usepackage{framed}\n"
        "\\usepackage{float}\n"
        "\\usepackage{fixltx2e}\n"
        "\\usepackage{tabularx}\n"
        "\\usepackage{mdframed}\n"
        "\\usepackage{graphicx}\n"
//        "\\usepackage{multicol}\n"

        "\\pagestyle{fancy}\n"
        "\\renewcommand{\\headrulewidth}{0pt}\n"
        "\\renewcommand\\lq{<<}\n"
        "\\renewcommand\\rq{>>}\n"
        "\\titleformat{\\chapter}{\\normalfont\\bfseries\\centering}{\\hspace{1.5em}\\MakeUppercase{\\chaptertitlename}\\ \\thechapter.}{-5.5em}{\\newline\\filcenter\\MakeUppercase}\n"
        "\\titleformat{\\section}{\\normalfont\\bfseries\\centering}{\\thesection.}{0.25em}{\\filcenter\\MakeUppercase}\n"
        "\\titleformat{\\subsection}{\\normalfont\\bfseries}{\\thesubsection.}{0.25em}{}\n"
        "\\lstdefinelanguage{kumir}{"
        "   morekeywords={алг,нач,кон,дано,надо,если,то,иначе,все,выбор,при,исп,кон_исп,нц,кц,кц_при,для,от,до,шаг,раз,пока,ввод,вывод,пауза,утв,арг,рез,аргрез,и,или,не,цел,вещ,лог,лит,сим,целтаб,вещтаб,логтаб,литтаб,симтаб,таб,нс,знач,да,нет,выход},"
        "   sensitive=true,"
        "   morecomment=[l]{\\|},"
        "   morestring=[b]\","
        "   morestring=[b]'"
        "}\n"
        "\\newcounter{Example}\n"
        "\\setcounter{Example}{0}\n"
        "\\newcounter{Figure}\n"
        "\\setcounter{Figure}{0}\n"
        "\\newcounter{Table}\n"
        "\\setcounter{Table}{0}\n"
        "\\floatstyle{boxed}\n"
        "\\newfloat{Example}{hbt}{exm}[Example]\n"
        "\\floatname{Example}{Пример}\n"
        "\\floatstyle{plain}\n"
        "\\newfloat{Figure}{btp}{fgr}[Figure]\n"
        "\\floatname{Figure}{Рисунок}\n"
        "\\floatstyle{plaintop}\n"
        "\\newfloat{Table}{hbt}{tbl}[Table]\n"
        "\\floatname{Table}{Таблица}\n"
        "\\newenvironment{FuncSynopsis}{"
        "\\par\\noindent\\textbf{Синтаксис:~}\\hspace{2em}}{\\vspace{18pt}}\n"
        "\\newenvironment{Abstract}{\\hrule\\par\\vspace{12pt}}{\\vspace{12pt}\\hrule\\vspace{18pt}}\n"
        "\\setlength{\\columnsep}{1cm}\n"
        "\\AtBeginDocument{\\addtocontents{toc}{\\protect\\thispagestyle{fancy}}}\n"
        "";

const char * DOCUMENT_BEGIN = ""
        "\\titlespacing{\\chapter}{0pt}{0pt}{72pt}\n"
        "\\titlespacing{\\section}{0pt}{36pt}{18pt}\n"
        "\\titlespacing{\\subsection}{0pt}{36pt}{18pt}\n"
        "\\selectlanguage{russian}\n"
        "\\lhead{}\n"
        "\\chead{--\\ \\thepage\\ --}\n"
        "\\rhead{}\n"
        "\\lfoot{}\n"
        "\\cfoot{}\n"
        "\\rfoot{}\n"
        "\\mdfsetup{"
        "innerleftmargin=0pt,"
        "innerrightmargin=0pt,"
        "innertopmargin=0pt,"
        "innerbottommargin=0pt"
        "}\n"

        "";

}

#endif // PREAMBULE_TEX_H
